#Simple PWM Motor Speed Control
from machine import Pin
from machine import ADC
from rotary import Rotary
import time

#PWM
motor = machine.PWM(machine.Pin(15)) #Motor Speed PWM pin
motor.freq(1000) #Frequency of PWM

#ROTARY ENCODER
rotary = Rotary(18,17,19) #DT (Direction), CK(Clock),SW(Switch)
val = 30000 #Starting PWM Duty Cycle
step = 100 #Step Size - change as you like

def rotary_changed(change): #Detect changes in the rotary encoder
    global val, step
    if change == Rotary.ROT_CW: #If rotated clockwise
        val = val + step #Add step value to current value
    elif change == Rotary.ROT_CCW: #If rotated counter-clockwise
        val = val - step #Remove step value from current value
    elif change == Rotary.SW_PRESS: #If button pressed
        print('Pressed') 
    elif change == Rotary.SW_RELEASE: #If Button released
        print('Released')

def motor_Speed():
    global val
    
    motor.duty_u16(val) #PWM duty value from Rotary encoder
    print(val)
    time.sleep(0.2) #0.2 second frame size
    
rotary.add_handler(rotary_changed) #Handler for rotary encoder

while True:
    motor_Speed() #Run the motor speed function